import javax.sound.sampled.Port;
import javax.lang.model.element.Element;
import javax.print.DocFlavor.STRING;
import java.util.Arrays;
import java.util.List;
import java.util.Random;

public class Poker {

    public String suit;
    public String values;
    public Poker(){
        values = "";
        suit = "";
    }
    public String getSuit(){
        return suit;
    }
    public String getValue(){
        return values;
    }
   
    //Metodo para cargar los valores y los palos
    public void setValues(String carta){
        values = ordenarCadena(values + String.valueOf(carta.charAt(0)));
        suit = ordenarCadena(suit + String.valueOf(carta.charAt(1)));
    }
    //Recibe un string y lo ordena segun orden numerico o alfabetico
    public String ordenarCadena(String original){
        String numeroAOrdenar = original;
        numeroAOrdenar = original;
        char[] chars = numeroAOrdenar.toCharArray();
        Arrays.sort(chars);
        String cadenaOrdenada = new String(chars);
        return cadenaOrdenada;
    }
    //***********CONTROLA LA JUGADA QUE SE DA EN LOS PALOS
    public String controlPalos(){
        String palos = suit;
        int contador = formulaYovan(palos);
        if (contador == 25) {
            return "COLOR";
        } else {
            //Para mejor manejo si no cumple ninguna de las condiciones envia una cadena vacia
            return "";
        }
    }
   //***********CONTROLA QUE JUGADA SE DA EN LOS VALORES
   public String controlValor(){
    String valores = values;
    int contador = formulaYovan(valores);
    int secuencial = 0;
    boolean thereIsLetter = false;
    if (contador < 6) {
        //controla que existan letras en los valores mandados
        for (int i = 0; i < valores.length(); i++) {
            String l = String.valueOf(valores.charAt(i));
            if (l == "T" || l == "J" || l == "Q" || l == "K" || l == "A") {
                thereIsLetter = true;
                break;
            }
        }
        //Una condicional para el caso que existan letras
        if(thereIsLetter == false){
            //Para mejor entendimiento visual lo guardo en una variable de nombre mas corto
            String v = getValue();
            if ( (v.equals("89JQT")) || (v.equals("9JKQT")) || ((v).equals("AJKQT")) ||(v.equals("2345A")) || (v.equals("789JT")) ||(v.equals("6789T"))){
                return "ESCALERA";
            }
        }else{
            for (int i = 1; i < valores.length(); i++) {
                if (Character.getNumericValue(valores.charAt(i)) == Character.getNumericValue(valores.charAt(i-1)) + 1) {
                        secuencial++;   
                }                
            }
            if (secuencial == 4) {
                return "ESCALERA";
            } 
        }   
    }else if (contador == 17) {
        return "POKER";
    }else if(contador == 13){
        return "FULL";
    }else if(contador == 11){
        return "TRIO";
    }else if(contador == 9){
        return "PAR DOBLE";
    }else if(contador == 7){
        return "PAR";
    } 
    //Para mejor manejo si no cumple ninguna de las condiciones envia una cadena vacia
    return "";
    }
    //Con este metodo controlo de que manera se repite el string que recibe el metodo(Formula de yorhan ;D )
    private int formulaYovan(String cadena){
        int contador = 0;
        for (int i = 0; i < cadena.length(); i++) {
            for (int j = 0; j < cadena.length(); j++) {
                if (cadena.charAt(i) == cadena.charAt(j)) {
                    contador++;
                }
            }
        }
        return contador;
    }
    //Con este metodo le doy valor numerico a la cadena valor
    public int valorCadenaNumerico(String strValue){
        int valorNumerico = 0;
        switch (controlValor()) {
            case "89JQT": valorNumerico = 50;
                break;
            case "9JKQT":valorNumerico = 55;
                break;
            case "AJKQT":valorNumerico = 60;
                break;
            case "2345A":valorNumerico = 15;
                break;
            case "789JT":valorNumerico = 45;
                break;
            case "6789T":valorNumerico = 40;
                break;
            default: 
            for (int i = 0; i < strValue.length(); i++) {valorNumerico = Character.valueOf(strValue.charAt(i));}
                break;
        }
        return valorNumerico;
    }
    public int valorJugadas(){
        int puntaje = 0;
        switch (controlValor()) {
            case "POKER": puntaje = 17;
                break;
            case "FULL": puntaje = 13;
                break;
            case "TRIO": puntaje = 11;
                break;
            case "PAR DOBLE": puntaje = 9;
                break;
            case "PAR": puntaje = 7;
                break;
            case "": puntaje = 1;
                break;
            default:
                break;
        }

        return puntaje;
    }
    //Metodo para generar cartas aleatorias
    public void repartirCartas(Carta carta){
        String [] valores = {"A","2","3","4","5","6","7","8","9","T","J","Q","K",};
        String [] palos = {"D","S","C","H",};
        carta.valor = (valores[(int)Math.floor(Math.random()*(11-0+1)+0)]);
        carta.palo = (palos[(int)Math.floor(Math.random()*(3-0+1)+0)]);
    }
    //Metodo para imprimir resultados de cada jugador
    public void imprimirResultados(Carta [] mano, int jugador){

        if ((controlValor() == "") && (controlPalos() == "" )) {
            System.out.print("jugador " + jugador + " : \n");
            System.out.print("Sus cartas son: [");
            for (int i = 0; i < mano.length; i++) {
                System.out.print(mano[i].valorPalo() + ",");
            }
            System.out.print("]\n");
            System.out.println("jugada: CARTA ALTA");
        }else{
            System.out.print("jugador " + jugador + " : \n");
            System.out.print("Sus cartas son: [");
            for (int i = 0; i < mano.length; i++) {
                System.out.print(mano[i].valorPalo() + ",");
            }
            System.out.print("]\n");
            System.out.println("Jugada: " + controlValor() + " " + controlPalos());
        }
    }

    public static void main(String[] args) {
        Carta carta1 = new Carta("BB");
        Carta carta2 = new Carta("BB"); 
        Carta carta3 = new Carta("BB");
        Carta carta4 = new Carta("BB");
        Carta carta5 = new Carta("BB");
        Carta carta6 = new Carta("BB");
        Carta carta7 = new Carta("BB"); 
        Carta carta8 = new Carta("BB");
        Carta carta9 = new Carta("BB");
        Carta carta10 = new Carta("BB");
        Poker jugador1 = new Poker();
        Poker jugador2 = new Poker();
        String [] cartas = new String [10];
        int control = 100;//Variable para controlar el ingreso de cartas repetidas
        Carta [] mano = new Carta[]{carta1,carta2,carta3,carta4,carta5,};
        Carta [] mano2 = new Carta[]{carta6,carta7,carta8,carta9,carta10,};
        while (control != 10) {
            control = 0;
            for (int i = 0; i < mano.length; i++) {
                //Se generan valores aleatorios para la primera mano
                jugador1.repartirCartas(mano[i]);
                //Se generan valores aleatorios para la segunda mano
                jugador2.repartirCartas(mano2[i]);
            }
            for (int i = 0; i < mano.length; i++) {
                for (int j = 0; j < mano.length; j++) {
                    if ((mano[i].valorPalo()).equals(mano[j].valorPalo())) {
                        control++;
                    }
                    if ((mano2[i].valorPalo()).equals(mano2[j].valorPalo())) {
                        control++;
                    }
                    if ((mano[i].valorPalo()).equals(mano2[j].valorPalo())) {
                        control++;
                    }
                }  
            }
        }
        //Le paso los valores con el metodo del profe
        for (int i = 0; i < mano.length; i++) {
            jugador1.setValues(mano[i].valorPalo());
            jugador2.setValues(mano2[i].valorPalo());
        }
        jugador1.imprimirResultados(mano,1);
        jugador2.imprimirResultados(mano2,2);
        //Decide el jugador con ayuda de metodos(Profe si sabes otra manera de decidir esto decime pls)
        if ((jugador1.controlValor() == jugador2.controlValor()) && (jugador1.controlPalos() == jugador2.controlPalos())) {
            if (jugador1.valorCadenaNumerico(jugador1.getValue())>jugador2.valorCadenaNumerico(jugador1.getValue())) {
                System.out.println("Gana el jugador 1");
            }else{
                System.out.println("Gana el jugador 2");
            }
        }else{
            if (jugador1.valorJugadas() >jugador2.valorJugadas()) {
                System.out.println("Gana el jugador 1");
            }else{
                System.out.println("Gana el jugador 2");
            }
        }

    }
}
